
      PROGRAM TDSYEV1
*
*       ணࠬ   PDSYEV1
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            LWORK, MAXN, LDA, MAXPROCS, NOUT
      DOUBLE PRECISION   ZERO, MONE
      PARAMETER          ( LDA = 100, LWORK = 264, MAXN = 100,
     $                   MAXPROCS = 512, NOUT =6, ZERO = 0.0D+0,
     $                   MONE = -1.0D+0 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'U' )
*     ..
*  ६ ..
      INTEGER            CONTEXT, I, IAM, INFO, MYCOL, MYROW, N, NB,
     $                   NPCOL, NPROCS, NPROW, IA, JA
*     ..
*  ᨢ ..
      INTEGER            DESCA( 9 )
      DOUBLE PRECISION   A( LDA, LDA ), W( MAXN ),
     $                   WORK( LWORK ), WORK1( 4 )
*     ..
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDMATINIT, PDLAPRNT,
     $                   PDSYEV1
*     ..
* 믮  ..
*
* ⠭ 
*
      N = 4
      NB = 1
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
*
* 樠  BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
      IF( ( NPROCS.LT.1 ) ) THEN
         CALL BLACS_SETUP( IAM, NPROW*NPCOL )
      END IF
*
* 樠 ⥪ BLACS'  ⪨ ᮢ
*
      CALL BLACS_GET( -1, 0, CONTEXT )
      CALL BLACS_GRIDINIT( CONTEXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CONTEXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨      ⥪,
* 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 20
*
* 樠 ਯ   A
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CONTEXT, LDA, INFO )
*
* ஥ ,    ᣥ஢
*   matlab:  hilb(n) + diag([1:-1/n:1/n])
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9992 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  A'
      END IF
 9985 FORMAT( / 9I5 /)
 9988 FORMAT( / ' UPLO = ', A /)
*
      CALL PDLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
* 襭 ஡ ᮡ⢥ 祭
*
      CALL PDSYEV1( UPLO, N, A, IA, JA, DESCA, W, WORK, LWORK, INFO )
*
*  १⮢
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ ᫠'
         DO 10 I = 1, N
            PRINT *, ' W(', I, ')=', W( I ), ';'
   10    CONTINUE
      END IF
*
      CALL BLACS_GRIDEXIT( CONTEXT )
*
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( 'W=diag([', 4D16.12, //']);' )
*
 9992 FORMAT( / '  ணࠬ PDSYEV1' )
 9998 FORMAT( / ' ᫥  ᮡ⢥ 祭   A,' //
     $      '  A - ᨬ筠  ',
     $      I2, '  ', I2,',' /
     $       '      ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, INFO )
*
* PDMATINIT   ।  A  ⪥ ᮢ
*
*  ⠭ - ࠬ ..
      INTEGER            DLEN_, CTXT_
      PARAMETER          ( DLEN_ = 9, CTXT_ = 2 )
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
* ࠬ - ६ ..
      INTEGER            IA, INFO, JA, N
*     ..
* ࠬ - ᨢ ..
      INTEGER            DESCA( * )
      DOUBLE PRECISION   A( * )
*     ..
*  ६ ..
      INTEGER            I, J, MYCOL, MYROW, NPCOL, NPROW
*     ..
* 譨 ணࠬ ..
      EXTERNAL           BLACS_GRIDINFO, PDELSET
*     ..
* ७ 㭪樨 ..
      INTRINSIC          DBLE
*     ..
* 믮  ..
*
      INFO = 0
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF( JA.NE.1 ) THEN
         INFO = -4
      END IF
*
      DO 20 J = 1, N
         DO 10 I = 1, N
            IF( I.EQ.J ) THEN
               CALL PDELSET( A, I, J, DESCA,
     $                       ( DBLE( N-I+1 ) ) / DBLE( N )+ONE /
     $                       ( DBLE( I+J )-ONE ) )
            ELSE
               CALL PDELSET( A, I, J, DESCA, ONE / ( DBLE( I+J )-ONE ) )
            END IF
   10    CONTINUE
   20 CONTINUE
      RETURN
*
*     End of PDMATINIT
      END
